package cn.skcks.docking.gb28181.wvp.api.video;

import cn.skcks.docking.gb28181.wvp.service.video.RecordService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.http.server.reactive.ServerHttpResponse;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.server.ServerWebExchange;
import reactor.core.publisher.Mono;

@Slf4j
@RequiredArgsConstructor
@RestController
@RequestMapping("/video/record")
public class RecordController {
    private final RecordService recordService;

    @RequestMapping(method = {RequestMethod.HEAD,RequestMethod.OPTIONS})
    public void record(ServerWebExchange exchange){
        recordService.header(exchange.getResponse());
    }

    @GetMapping
    public Mono<Void> record(ServerWebExchange exchange, @RequestParam String url, @RequestParam long time){
        log.info("{} {}", url,time);
        return recordService.record(exchange.getResponse(),url,time);
    }
}
