package cn.skcks.docking.gb28181.wvp.config;

import cn.hutool.core.util.ReUtil;
import jakarta.validation.constraints.NotNull;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.server.ServerWebExchange;
import org.springframework.web.server.WebFilter;
import org.springframework.web.server.WebFilterChain;
import reactor.core.publisher.Mono;

import java.net.InetSocketAddress;
import java.util.Optional;


@Slf4j
@Configuration
@RequiredArgsConstructor
public class WebConfig implements WebFilter {

    @Override
    public Mono<Void> filter(ServerWebExchange exchange, WebFilterChain chain) {
        String path = exchange.getRequest().getPath().toString();
        if(ReUtil.isMatch(".*/swagger-ui/.*",path) || ReUtil.isMatch("/v3/api-docs.*",path) ){
            return chain.filter(exchange);
        } else {
            String ip = Optional.ofNullable(exchange.getRequest().getRemoteAddress())
                    .orElse(new InetSocketAddress("0.0.0.0",0)).getHostString();
            log.info("{} 访问 {}", ip, path);
        }
        return chain.filter(exchange);
    }
}
